<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Order Detail</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.3.1/dist/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <style>
        .container-box {
           margin: 50px;

        }
        h2 {
            text-align: center;
        }
        .form-box {
            display: flex;
            justify-content: space-evenly;
        }

        .inp-group {
            display: flex;
            flex-direction: row;
            align-items: center;
        }
        label {
            width: 150px;
            margin: 20px 0px;
            text-align: right;
            padding-right: 10px;
        }
        .button-box {
            margin-left: 100px;
        }
        .btn-confirm {
            background-color: #28A745;
            color: white;
            width: 100px;
        }
        .btn-cancel {
            background-color: #17A2B8;
            color: white;
            width: 100px;
        }
    </style>
</head>
<body onload="onPageLoading()">
    <div class="container-box container-fluid">
        <h2>Order Detail !!!</h2>
        <form id="orderForm" class="">
            <div class=" form-box form-row">
                <!-- left column -->
                <div class=" col-left col-md-5 mb-3">
                    <div class="inp-group ">
                        <label class="" for="id-order-code">Order Code</label>
                        <input type="text" class="form-control" id="id-order-code" placeholder="">
                    </div>
                    <div class="inp-group">
                        <label for="id-duong-kinh">Đường kính pizza</label>
                        <input type="text" class="form-control" id="id-duong-kinh" placeholder="">
                    </div>
                    <div class="inp-group">
                        <label for="id-do-uong">Đồ uống</label>
                        <select class="form-control" name="" id="id-do-uong">
                            <option value="0">Chọn đồ uống</option>
                        </select>
                    </div>
                    <div class="inp-group">
                        <label for="id-voucher">Voucher Id</label>
                        <input type="text" class="form-control" id="id-voucher" placeholder="">
                    </div>
                    <div class="inp-group">
                        <label for="id-salad">Salad</label>
                        <input type="text" class="form-control" id="id-salad" placeholder="">
                    </div>
                    <div class="inp-group">
                        <label for="id-giam-gia">Giảm giá</label>
                        <input type="text" class="form-control" id="id-giam-gia" placeholder="">
                    </div>
                    <div class="inp-group">
                        <label for="id-email">Email</label>
                        <input type="text" class="form-control" id="id-email" placeholder="">
                    </div>

                    <div class="inp-group">
                        <label for="id-dia-chi">Địa chỉ</label>
                        <input type="text" class="form-control" id="id-dia-chi" placeholder="">
                    </div>
                    <div class="inp-group">
                        <label for="id-trang-thai">Trạng thái đơn hàng</label>
                        <select class="form-control" name="" id="id-trang-thai">
                            <option value="0">Trạng thái</option>
                        </select>
                    </div>
                    <div class="inp-group">
                        <label for="id-ngaycapnhat">Ngày cập nhật</label>
                        <input type="text" class="form-control" id="id-ngaycapnhat" placeholder="">
                    </div>
                </div>
                <!-- right column -->
                <div class=" col-right col-md-5 mb-3">
                    <div class="inp-group">
                        <label for="id-co-combo">Cỡ combo</label>
                        <select class="form-control" name="" id="id-co-combo">
                            <option value="0">Chọn cỡ Combo (Combo Size)</option>
                        </select>
                    </div>
                    <div class="inp-group">
                        <label for="id-suon-nuong">Sườn nướng (miếng)</label>
                        <input type="text" class="form-control" id="id-suon-nuong" placeholder="">
                    </div>
                    <div class="inp-group">
                        <label for="id-soluongnuocuong">Số lượng nước uống</label>
                        <input type="text" class="form-control" id="id-soluongnuocuong" placeholder="">
                    </div>
                    <div class="inp-group">
                        <label for="id-loai-pizza">Loại Pizza</label>
                        <select class="form-control" name="" id="id-loai-pizza">
                            <option value="0">Chọn loại pizza</option>
                        </select>
                    </div>
                    <div class="inp-group">
                        <label for="id-thanh-tien">Thành tiền</label>
                        <input type="text" class="form-control" id="id-thanh-tien" placeholder="">
                    </div>
                    <div class="inp-group">
                        <label for="id-ho-ten">Họ và tên</label>
                        <input type="text" class="form-control" id="id-ho-ten" placeholder="">
                    </div>
                    <div class="inp-group">
                        <label for="id-sdt">Số điện thoại</label>
                        <input type="text" class="form-control" id="id-sdt" placeholder="">
                    </div>
                    <div class="inp-group">
                        <label for="id-loi-nhan">Lời nhắn</label>
                        <input type="text" class="form-control" id="id-loi-nhan" placeholder="">
                    </div>
                    <div class="inp-group">
                        <label for="id-ngaytaodon">Ngày tạo đơn</label>
                        <input type="text" class="form-control" id="id-ngaytaodon" placeholder="">
                    </div>
                </div>
            </div>
            <div class="button-box">
                <button onclick="onBtnConfirmClick()" class="btn btn-confirm">Confirm</button>
                <button onclick="onBtnCancelClick()" class="btn btn-cancel">Cancel</button>
            </div>
        </form>
    </div>
</body>
<script>
    //region 1: global variables
    const gDETAIL_FORM_URL = "orderDetail.html";
    const gINDEX_LIST_URL = "indexListView.html";

    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
    const gREQUEST_DELETE_SUCCESS = 204; // status 204 - Xóa thành công
    // bien query 
    var vQueryObj = {
            id: "",
            orderCode: ""
        };

    //region 2: khai bao xu ly bien
        /*Task 31.30*/
    var vForm = document.getElementById("orderForm");
    vForm.addEventListener("submit", function(e) {
        e.preventDefault();
    })
    //region 3: khai bao ham xu ly su kien
    function onPageLoading() {
        /*XỬ LÝ QUERY STRING*/
        // b0: tạo đối tượng

        // b1: thu thập dữ liệu
        //  get data from query string
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString);
        console.log(vUrl);
        // get data from searchParams of vUrl
        getDataFromSearchParams(vUrl, vQueryObj);
        console.log(vQueryObj);
        // b2: kiểm tra dữ liệu
        var vCheck = validateQueryString(vQueryObj);
        console.log("validateQueryString: " + vCheck);
        // b3: xu ly hien thi
        if (vCheck == false) {
            window.location.href = gINDEX_LIST_URL;
        } else {
            console.log("Id: " + vQueryObj.id);
            console.log("Order Code: " + vQueryObj.orderCode);
        }
        /* XỬ LÝ API*/
        // b1, b2, da thuc hien
        // b3: xu ly ajax
        var vXmlHttpGetOrderById = new XMLHttpRequest();
        processAPIOrder(vXmlHttpGetOrderById, vQueryObj.orderCode);
        vXmlHttpGetOrderById.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vXHOrderResponseText = JSON.parse(vXmlHttpGetOrderById.responseText);
                    console.log(vXHOrderResponseText);
                    displayOrder(vXHOrderResponseText);

                }
            }

    }
    // /*Task 31.30*/
    // function onBtnConfirmClick() {
    //     // b1: thu thap du lieu -> vOrderSendObj
    //     // b2: kiem tra du lieu

    //     // b3: xử lý ajax
    //     var vObjectRequest = {
    //         trangThai: "confirmed" //3 trạng thái: open, confirmed, cancel
    //     }
    //     var vQueryId = vQueryObj.id;
    //     console.log(vQueryId);
    //     var vXmlHttpUpdateOrder = new XMLHttpRequest();
    //     vStringRequest = JSON.stringify(vObjectRequest)
    //     processAPIOrderUpdate(vXmlHttpUpdateOrder, vStringRequest, vQueryId);
    //     // bước 4: hiển thị
    //     vXmlHttpUpdateOrder.onreadystatechange =
    //         function () {
    //             if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
    //                 var vUpdatedOrder = vXmlHttpUpdateOrder.responseText;
    //                 console.log(vUpdatedOrder);
    //             }
    //         }

    // }

    function onBtnConfirmClick() {
        vQueryId = vQueryObj.id;
        var vObjectRequest = {
            trangThai: "confirmed" //3 trạng thái: open, confirmed, cancel
        }

        var vXmlHttpUpdateOrder = new XMLHttpRequest();
        processAPIOrderUpdate(vXmlHttpUpdateOrder, vQueryId, vObjectRequest)
        vXmlHttpUpdateOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vUpdatedOrder = vXmlHttpUpdateOrder.responseText;
                    console.log(vUpdatedOrder);
                }
            }
    }

    function onBtnCancelClick() {
        vQueryId = vQueryObj.id;
        var vObjectRequest = {
            trangThai: "cancel" //3 trạng thái: open, confirmed, cancel
        }

        var vXmlHttpUpdateOrder = new XMLHttpRequest();
        processAPIOrderUpdate(vXmlHttpUpdateOrder, vQueryId, vObjectRequest)
        vXmlHttpUpdateOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vUpdatedOrder = vXmlHttpUpdateOrder.responseText;
                    console.log(vUpdatedOrder);
                }
            }
    }

    //region 4: khai bao ham dung chung

    function getDataFromSearchParams(paramUrl, paramQuery) {

        paramQuery.id = paramUrl.searchParams.get("id");
        paramQuery.orderCode = paramUrl.searchParams.get("ordercode");
    }

    function validateQueryString(paramQueryObj) {
        vResult = true;
        if (paramQueryObj.id == null) {
            alert("Query string không chứa id!")
            vResult = false;
        }
        if (paramQueryObj.orderCode == null) {
            alert("Query string không chứa Order Code!")
            vResult = false;
        }
        return vResult;
    }

    function processAPIOrder(paramXHTMLRequest, paramOrderCode) {
        paramXHTMLRequest.open("GET", gBASE_URL + "/" + paramOrderCode, true);
        paramXHTMLRequest.send();
    }
    function displayOrder(paramOrder) {
        // truy xuat phan tu
        var vOrderCode = document.getElementById("id-order-code");
        var vDuongKinh = document.getElementById("id-duong-kinh");
        var vDrink = document.getElementById("id-do-uong");
        var vVoucher = document.getElementById("id-voucher");
        var vSalad = document.getElementById("id-salad");
        var vGiamGia = document.getElementById("id-giam-gia");
        var vEmail = document.getElementById("id-email");
        var vDiaChi = document.getElementById("id-dia-chi");
        var vTrangThai = document.getElementById("id-trang-thai");
        var vNgayCapNhat = document.getElementById("id-ngaycapnhat");
        var vCoCombo = document.getElementById("id-co-combo");
        var vSuonNuong = document.getElementById("id-suon-nuong");
        var vSoLuongNuoc = document.getElementById("id-soluongnuocuong");
        var vLoaiPizza = document.getElementById("id-loai-pizza");
        var vThanhTien = document.getElementById("id-thanh-tien");
        var vHoTen = document.getElementById("id-ho-ten");
        var vSoDienThoai = document.getElementById("id-sdt");
        var vLoiNhan = document.getElementById("id-loi-nhan");
        var vNgayTaoDon = document.getElementById("id-ngaytaodon");
        // cap nhat du lieu cho phan tu
        //input
        vOrderCode.value = paramOrder.orderCode;
        vDuongKinh.value = paramOrder.duongKinh;
        vVoucher.value = paramOrder.idVourcher;
        vSalad.value = paramOrder.salad;
        vGiamGia.value = paramOrder.giamGia;
        vEmail.value = paramOrder.email;
        vDiaChi.value = paramOrder.diaChi;
        vSuonNuong.value = paramOrder.suon;
        vSoLuongNuoc.value = paramOrder.soLuongNuoc;
        vThanhTien.value = paramOrder.thanhTien;
        vHoTen.value = paramOrder.hoTen;
        vSoDienThoai.value = paramOrder.soDienThoai;
        vLoiNhan.value = paramOrder.loiNhan;
        // select
        // vDrink.value = paramOrder.idLoaiNuocUong;
        vDrink.innerHTML = "";
        var vOptionDrink = document.createElement("option");
        vOptionDrink.text =  paramOrder.idLoaiNuocUong;
        vDrink.appendChild(vOptionDrink);

        // vLoaiPizza.value = paramOrder.loaiPizza;
        vLoaiPizza.innerHTML = "";
        var vOptionLoaiPizza = document.createElement("option");
        vOptionLoaiPizza.text =  paramOrder.loaiPizza;
        vLoaiPizza.appendChild(vOptionLoaiPizza);

        // vTrangThai.value = paramOrder.trangThai;
        vTrangThai.innerHTML = "";
        var vOptionTrangThai = document.createElement("option");
        vOptionTrangThai.text =  paramOrder.trangThai;
        vTrangThai.appendChild(vOptionTrangThai);

        // vCoCombo.value = paramOrder.kichCo;
        vCoCombo.innerHTML = "";
        var vOptionCoCombo = document.createElement("option");
        vOptionCoCombo.text =  paramOrder.kichCo;
        vCoCombo.appendChild(vOptionCoCombo);

        // date
        vNgayCapNhat.value = new Date(paramOrder.ngayCapNhat).toLocaleDateString("en-GB");
        vNgayTaoDon.value = new Date(paramOrder.ngayTao).toLocaleDateString("en-GB");
    }
    // hàm xử lý ajax thêm order
    function processAPIOrderUpdate(paramXHTMLUpdateRequest, paramId, paramObjRequest) {
        paramXHTMLUpdateRequest.open("PUT", gBASE_URL + "/" + paramId);
        paramXHTMLUpdateRequest.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        paramXHTMLUpdateRequest.send(JSON.stringify(paramObjRequest));
    }
</script>
</html>